<template>
   
  <div class="app-container">
    <el-card class="filter-container" shadow="never">
      <div>
        <i class="el-icon-search"></i>
        <span>筛选搜索</span>

        <el-button
          style="float: right; "
          @click="onExport()"
          size="small"
          type="danger"
        >
          导出
        </el-button>
        <el-button
          style="float: right; margin-right: 15px"
          type="primary"
          @click="handleSearchList()"
          size="small"
        >
          查询搜索
        </el-button>
        <el-button
          style="float: right; margin-right: 15px"
          @click="handleResetSearch()"
          size="small"
        >
          重置
        </el-button>

      </div>
      <div style="margin-top: 15px">
        <el-form
          :inline="true"
          :model="listQuery"
          size="small"
          label-width="140px"
        >
          <el-form-item label="输入搜索：">
            <el-input
              v-model="listQuery.orderSn"
              class="input-width"
              placeholder="订单编号"
            ></el-input>
          </el-form-item>
          <el-form-item label="收货人：">
            <el-input
              v-model="listQuery.receiverKeyword"
              class="input-width"
              placeholder="收货人姓名/手机号码"
            ></el-input>
          </el-form-item>
          <el-form-item label="提交时间：">
            <el-date-picker
              class="input-width"
              v-model="listQuery.dateRange"
              value-format="yyyy-MM-dd"
              type="daterange"
              placeholder="请选择时间"
              range-separator="~"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
              style="width: 260px;"
            >
            </el-date-picker>
          </el-form-item>
          <el-form-item label="订单状态：">
            <el-select
              v-model="listQuery.status"
              class="input-width"
              placeholder="全部"
              clearable
            >
              <el-option
                v-for="item in statusOptions"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="订单分类：">
            <el-select
              v-model="listQuery.orderType"
              class="input-width"
              placeholder="全部"
              clearable
            >
              <el-option
                v-for="item in orderTypeOptions"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="订单来源：">
            <el-select
              v-model="listQuery.sourceType"
              class="input-width"
              placeholder="全部"
              clearable
            >
              <el-option
                v-for="item in sourceTypeOptions"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-form>
      </div>
    </el-card>
    <el-card class="operate-container" shadow="never">
      <div style="display: flex; align-items: center;"><div>
        <i class="el-icon-tickets"></i>
        <span>数据列表</span>
      </div>
        <el-button
          style="margin-left: 15px;"
          type="primary"
           @click="handleBatchOperate()"
          size="small"
        >
          批量发货
        </el-button></div>
    </el-card>
    <div class="table-container">
      <!-- @selection-change="handleSelectionChange" -->
      <el-table
        ref="orderTable"
        :data="list"
        style="width: 100%"
        @select="onTableSelect"
        @select-all="onTableSelectALL"
        v-loading="listLoading"
        border
      >
        <el-table-column
          type="selection"
          width="55"
          :selectable="checkSelectable"
          align="center"
        ></el-table-column>
        <el-table-column label="编号" width="80" align="center">
          <template slot-scope="scope">{{ scope.row.id }}</template>
        </el-table-column>
        <el-table-column label="订单编号" width="180" align="center">
          <template slot-scope="scope">{{ scope.row.orderSn }}</template>
        </el-table-column>
        <el-table-column label="提交时间" width="180" align="center">
          <template slot-scope="scope">{{
            scope.row.createTime | formatCreateTime
          }}</template>
        </el-table-column>
        <el-table-column label="来源" align="center">
          <template slot-scope="scope">{{ scope.row.orderFormType | formatOrderFormType }}</template>
        </el-table-column>
        <el-table-column label="用户类型" align="center">
          <template slot-scope="scope">
            <p v-if="scope.row.platformType == 'STUDENT'">学生</p>
            <p v-else-if="scope.row.platformType == 'TEACHER'">老师</p>
            <p v-else-if="scope.row.platformType == 'SCHOOL'">学校</p>
            <p v-else>--</p>
          </template>
        </el-table-column>
        <el-table-column label="用户编号" align="center">
          <template slot-scope="scope">{{ scope.row.userId }}</template>
        </el-table-column>
        <el-table-column label="用户名" align="center">
          <template slot-scope="scope">{{ scope.row.username }}</template>
        </el-table-column>
        <el-table-column label="手机号" align="center">
          <template slot-scope="scope">{{ scope.row.phone || '-' }}</template>
        </el-table-column>
        <el-table-column label="订单金额" width="120" align="center">
          <template slot-scope="scope">￥{{ scope.row.totalAmount }}</template>
        </el-table-column>
        <el-table-column label="支付方式" width="120" align="center">
          <template slot-scope="scope">
          <span v-if="scope.row.sourceType != 2 && scope.row.sourceType != 3  && scope.row.sourceType != 4 ">
            {{
            scope.row.payType | formatPayType
          }}
          </span>
          <span v-else>-</span>
          </template>
        </el-table-column>
        <el-table-column label="订单来源" width="120" align="center">
          <template slot-scope="scope">{{
            scope.row.sourceType | formatSourceType
          }}</template>
        </el-table-column>
        <el-table-column label="订单状态" width="120" align="center">
          <template slot-scope="scope">{{
            scope.row.status | formatStatus
          }}</template>
        </el-table-column>
        <el-table-column label="操作" width="200" align="center">
          <template slot-scope="scope">
            <p class="table-btn-group">
            <el-button
              size="mini"
              @click="handleViewOrder(scope.$index, scope.row)"
              >查看订单</el-button
            >
            <el-button
              size="mini"
              type="danger"
              @click="handleCloseOrder(scope.$index, scope.row)"
              v-show="scope.row.status === 0 || scope.row.status === 1 || scope.row.status === 2 || scope.row.status === 3"
              >关闭订单</el-button
            >
            <el-button
              size="mini"
              @click="handleDeliveryOrder(scope.$index, scope.row)"
              v-show="scope.row.status === 1"
              >订单发货</el-button
            >
             <el-button
              size="mini"
              type="success"
              @click="handleOverOrder(scope.$index, scope.row)"
              v-show="scope.row.status === 1"
              >完成订单</el-button
            >
            <!-- <el-button
              size="mini"
              @click="handleViewLogistics(scope.$index, scope.row)"
              v-show="scope.row.status===2||scope.row.status===3">订单跟踪</el-button> -->
            <!-- <el-button
              size="mini"
              type="danger"
              @click="handleDeleteOrder(scope.$index, scope.row)"
              v-show="scope.row.status === 4"
              >删除订单</el-button
            > -->
            </p>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <!-- <div class="batch-operate-container">
      <el-select size="small" v-model="operateType" placeholder="批量操作">
        <el-option
          v-for="item in operateOptions"
          :key="item.value"
          :label="item.label"
          :value="item.value"
        >
        </el-option>
      </el-select>
      <el-button
        style="margin-left: 20px"
        class="search-button"
        @click="handleBatchOperate()"
        type="primary"
        size="small"
      >
        确定
      </el-button>
    </div> -->
    <div class="pagination-container">
      <el-pagination
        background
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        layout="total, sizes,prev, pager, next,jumper"
        :current-page.sync="listQuery.pageNum"
        :page-size="listQuery.pageSize"
        :page-sizes="[5, 10, 15]"
        :total="total"
      >
      </el-pagination>
    </div>
    <el-dialog
      title="关闭订单"
      :visible.sync="closeOrder.dialogVisible"
      width="30%"
    >
      <el-form :model="closeOrder" label-width="150px" ref="closeOrder">
        <el-form-item
          label="操作备注："
          prop="content"
          :rules="[
            { required: true, message: '请填写操作备注', trigger: 'blur' },
          ]"
        >
          <el-input v-model="closeOrder.content" type="textarea" rows="3">
          </el-input>
        </el-form-item>
      </el-form>

      <!-- <span style="vertical-align: top">操作备注：</span>

      <el-input
        style="width: 80%"
        type="textarea"
        :rows="5"
        placeholder="请输入内容"
        v-model="closeOrder.content"
      >
      </el-input> -->
      <span slot="footer" class="dialog-footer">
        <el-button @click="closeOrder.dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="handleCloseOrderConfirm"
          >确 定</el-button
        >
      </span>
    </el-dialog>
    <logistics-dialog v-model="logisticsDialogVisible"></logistics-dialog>
  </div>
</template>
<script>
import { fetchList, closeOrder, deleteOrder, updateOrderSuccess } from "@/api/order";
import { formatDate } from "@/utils/date";
import { Export } from "@/utils/downLoadFile";
import dayjs from 'dayjs'
import LogisticsDialog from "@/views/oms/order/components/logisticsDialog";
const defaultListQuery = {
  pageNum: 1,
  pageSize: 10,
  orderSn: null,
  receiverKeyword: null,
  status: null,
  orderType: null,
  sourceType: null,
  dateRange: [],
  createTime: null,
  endTime: null,
};
export default {
  name: "orderList",
  components: { LogisticsDialog },
  data() {
    return {
      listQuery: Object.assign({}, defaultListQuery),
      listLoading: true,
      list: null,
      total: null,
      operateType: 1,  // 默认批量发货
      multipleSelection: [],
      closeOrder: {
        dialogVisible: false,
        content: null,
        orderIds: [],
      },
      statusOptions: [
        {
          label: "待付款",
          value: 0,
        },
        {
          label: "待发货",
          value: 1,
        },
        {
          label: "已发货",
          value: 2,
        },
        {
          label: "已完成",
          value: 3,
        },
        {
          label: "已关闭",
          value: 4,
        },
      ],
      orderTypeOptions: [
        {
          label: "正常订单",
          value: 0,
        },
        {
          label: "秒杀订单",
          value: 1,
        },
      ],
      sourceTypeOptions: [
        {
          label: "PC订单",
          value: 0,
        },
        {
          label: "APP订单",
          value: 1,
        },
        {
          label: "学校采购",
          value: 2,
        },
        {
          label: "个人订单",
          value: 3,
        },
      ],
      operateOptions: [
        {
          label: "批量发货",
          value: 1,
        },
        {
          label: "关闭订单",
          value: 2,
        },
        {
          label: "删除订单",
          value: 3,
        },
      ],
      logisticsDialogVisible: false,
    };
  },
  created() {
    this.getList();
    // console.log(this.$route)
    if (this.$route.params.status + "") {
      this.listQuery.status = this.$route.params.status;
    }
    if(this.$route.query.orderSn){
      this.listQuery.orderSn = this.$route.query.orderSn
    }
  },
  filters: {
    formatCreateTime(time) {
      let date = new Date(time);
      return formatDate(date, "yyyy-MM-dd hh:mm:ss");
    },
    formatPayType(value) {
      if (value === 1) {
        return "支付宝";
      } else if (value === 2) {
        return "微信";
      } else if (value === 3) {
        return "余额";
      }else {
        return "未支付";
      }
    },
    formatOrderFormType(value) {
      if(value === 'MEC') {
        return '管乐迷'
      }
    },
    formatSourceType(value) {
      // 0->PC订单；1->app订单 2->学校采购 3 个人订单 4 其他订单")
      if(value === 0) {
        return "PC订单";
      } else if (value === 1) {
        return "APP订单";
      } else if (value === 2) {
        return "学校采购";
      } else if (value === 3) {
        return "个人订单";
      } else {
        return "其他订单";
      }
    },
    formatStatus(value) {
      if (value === 1) {
        return "待发货";
      } else if (value === 2) {
        return "已发货";
      } else if (value === 3) {
        return "已完成";
      } else if (value === 4) {
        return "已关闭";
      } else if (value === 5) {
        return "无效订单";
      } else {
        return "待付款";
      }
    },
  },
  methods: {
    checkSelectable(row) {
      return row.status === 1 ? true : false;
    },
    handleResetSearch() {
      this.listQuery = Object.assign({}, defaultListQuery);
    },
    handleSearchList() {
      this.listQuery.pageNum = 1;
      this.getList();
    },
    // handleSelectionChange(val) {
    //   console.log(val, 'val')
    //   this.multipleSelection = val;
    // },
    onTableSelectALL(val) {
      const list = this.list || []

      if(val.length > 0) {
        const sIds = this.multipleSelection.map((item) => {
          return item.id
        })
        val.forEach((item) => {
          if(sIds.indexOf(item.id) == -1) {
            this.multipleSelection.push(item)
          }
        })
      } else {
        const ids = list.map((item) => {
          return item.id
        })

        const sIds = this.multipleSelection.map((item) => {
          return item.id
        })

        const removeIds = []
        ids.forEach((item) => {
          if(sIds.indexOf(item) !== -1) {
            removeIds.push(item)
          }
        })

        console.log(ids, sIds, 'sids', removeIds)
        const temp = []
        this.multipleSelection.forEach((item) => {
          if(removeIds.indexOf(item.id) === -1) {
            temp.push(item)
          }
        })

        this.multipleSelection = temp
      }
    },
    onTableSelect(rows, row) {
      let idList = this.multipleSelection.map((group) => {
        return group.id;
      });


      let inIdList = rows.map((group) => {
        return group.id;
      });
      const isAdd = inIdList.indexOf(row.id) === -1 ? false : true

      if(isAdd) {
        if(idList.indexOf(row.id) === -1) {
          this.multipleSelection.push(row)
        }
      } else {
        if(idList.indexOf(row.id) !== -1) {
          this.multipleSelection.splice(idList.indexOf(row.id), 1)
        }
      }
    },
    handleViewOrder(index, row) {
      this.$router.push({ path: "/oms/orderDetail", query: { id: row.id } });
    },
    handleCloseOrder(index, row) {
      // this.closeOrder.dialogVisible = true;
      // this.closeOrder.content = "";
      // this.closeOrder.orderIds = [row.id];
      //
      const message = row.status === 2 || row.deliveryTime ? '该订单已发货，关闭后将自动返还库存？' :'是否要关闭订单？'
      this.$confirm(message, "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        updateOrderSuccess({ ids: [row.id], status: 4 }).then((response) => {
          this.$message({
            message: "关闭成功！",
            type: "success",
            duration: 1000,
          });
          this.getList();
        });
      });
    },
    handleDeliveryOrder(index, row) {
      let listItem = this.covertOrder(row);
      this.$router.push({
        path: "/oms/deliverOrderList",
        query: { list: [listItem] },
      });
    },
    /** 完成订单 */
    handleOverOrder(index, row) {
      this.$confirm("是否要完成订单?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        // let obj = {
        //   ids:ids.join(',')
        // }
        updateOrderSuccess({ ids: [row.id], status: 3 }).then((response) => {
          this.$message({
            message: "完成成功！",
            type: "success",
            duration: 1000,
          });
          this.getList();
        });
      });
    },
    handleViewLogistics(index, row) {
      this.logisticsDialogVisible = true;
    },
    handleDeleteOrder(index, row) {
      let ids = [];
      ids.push(row.id);
      this.deleteOrder(ids);
    },
    handleBatchOperate() {
      if (this.multipleSelection == null || this.multipleSelection.length < 1) {
        this.$message({
          message: "请选择要操作的订单",
          type: "warning",
          duration: 1000,
        });
        return;
      }
      if (this.operateType === 1) {
        //批量发货
        let list = [];
        for (let i = 0; i < this.multipleSelection.length; i++) {
          if (this.multipleSelection[i].status === 1) {
            list.push(this.covertOrder(this.multipleSelection[i]));
          }
        }
        // 
        if (list.length === 0) {
          this.$message({
            message: "选中订单中没有可以发货的订单",
            type: "warning",
            duration: 1000,
          });
          return;
        }
        this.$router.push({
          path: "/oms/deliverOrderList",
          query: { list: list },
        });
      } else if (this.operateType === 2) {
        //关闭订单
        this.closeOrder.orderIds = [];
        for (let i = 0; i < this.multipleSelection.length; i++) {
          this.closeOrder.orderIds.push(this.multipleSelection[i].id);
        }
        this.closeOrder.dialogVisible = true;
      } else if (this.operateType === 3) {
        //删除订单
        let ids = [];
        for (let i = 0; i < this.multipleSelection.length; i++) {
          ids.push(this.multipleSelection[i].id);
        }
        this.deleteOrder(ids);
      }
    },
    handleSizeChange(val) {
      this.listQuery.pageNum = 1;
      this.listQuery.pageSize = val;
      this.getList();
    },
    handleCurrentChange(val) {
      this.listQuery.pageNum = val;
      this.getList();
    },
    handleCloseOrderConfirm() {
      // if (this.closeOrder.content == null || this.closeOrder.content === "") {
      //   this.$message({
      //     message: "操作备注不能为空",
      //     type: "warning",
      //     duration: 1000,
      //   });
      //   return;
      // }

      this.$refs.closeOrder.validate((valid) => {
        if (valid) {
          // let params = new URLSearchParams();
          // params.append("ids", this.closeOrder.orderIds);
          // params.append("note", this.closeOrder.content);
          let obj = {
            ids:this.closeOrder.orderIds.join(','),
            note: this.closeOrder.content
          }
          closeOrder(obj).then((response) => {
            this.closeOrder.orderIds = [];
            // this.closeOrder.dialogVisible = false;
            (this.closeOrder = {
              dialogVisible: false,
              content: null,
              orderIds: [],
            }),
              this.getList();
            this.$message({
              message: "修改成功",
              type: "success",
              duration: 1000,
            });
          });
        }
      });
    },
    getList() {
      this.listLoading = true;
      console.log(this.listQuery, 'listQuery')
      let { dateRange, createTime, endTime, ...res } = this.listQuery
      if(dateRange && dateRange.length > 0) {
        createTime = dayjs(dateRange[0]).format('YYYY-MM-DD')
        endTime = dayjs(dateRange[1]).format('YYYY-MM-DD')
      }
      fetchList({
        createTime: createTime,
        endTime: endTime,
        ...res
      }).then((response) => {
        // this.listLoading = false;
        this.list = response.data.list;
        this.total = response.data.total;

        this.$nextTick(() => {
            if (this.multipleSelection) {
              let idList = this.multipleSelection.map((item, index) => {
                return item.id;
              });
              this.list.forEach((item, index) => {
                if (idList.indexOf(item.id) != -1) {
                  // 判断当前选中的是否为已发货数据
                  if(item.status === 1) {
                    this.$refs.orderTable.toggleRowSelection(item, true);
                  } else {
                    const mId = this.multipleSelection.findIndex((c) => c.id === item.id)
                    this.multipleSelection.splice(mId, 1)
                  }
                }
              });
            }
            this.listLoading = false;
          });
      });
    },
    deleteOrder(ids) {
      this.$confirm("是否要进行该删除操作?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        // let params = new URLSearchParams();
        // params.append("ids", ids);
        let obj = {
          ids:ids.join(',')
        }
        deleteOrder(obj).then((response) => {
          this.$message({
            message: "删除成功！",
            type: "success",
            duration: 1000,
          });
          this.getList();
        });
      });
    },
    covertOrder(order) {
      let address =
        order.receiverProvince +
        order.receiverCity +
        order.receiverRegion +
        order.receiverDetailAddress;
      let listItem = {
        orderId: order.id,
        orderSn: order.orderSn,
        receiverName: order.receiverName,
        receiverPhone: order.receiverPhone,
        receiverPostCode: order.receiverPostCode,
        address: address,
        deliveryCompany: null,
        deliverySn: null,
        isError: false
      };
      return listItem;
    },
    onExport() {
      Export(
        this,
        {
          url: "/api-mall-admin/export/orderDetail",
          fileName: "订单列表.xls",
          method: "post",
          params: { ...this.listQuery },
        },
        "您确定导出订单列表?"
      );
    },
  },
};
</script>
<style scoped>
.input-width {
  width: 203px;
}
.table-btn-group {
  .el-button {
    margin: 5px 3px;
  }

}
</style>


